
        CHANGES IN spatstat.explore VERSION 3.8-2

OVERVIEW

    o We thank Lindsay Clark for contributions.

    o Adaptive kernel smoothing of mark values.
    
    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o SmoothAdaptiveKernel.ppp
    Adaptive kernel smoothing of mark values of a point pattern.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o rhohat.ppp, rhohat.quad
    Methods for 'rhohat' now recognise the argument 'delta'
    as an alternative to argument 'breaks' when smoother="piecewise".
    
    o pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom
    Now recognise argument 'ratio'.
    If 'ratio=TRUE', the numerator and denominator of each estimate
    are saved, for use in analysing replicated point patterns.

    o Kcross.inhom, Kdot.inhom, Kmulti.inhom, Lcross.inhom, Ldot.inhom
    Now recognise argument 'ratio'.
    If 'ratio=TRUE', the numerator and denominator of each estimate
    are saved, for use in analysing replicated point patterns.

BUG FIXES

    o pcfinhom
    The result was incorrectly labelled (in the internal function labels)
    as if it were the result of 'pcf' rather than 'pcfinhom'.
    Fixed.


        CHANGES IN spatstat.explore VERSION 3.8-1

OVERVIEW

    o We thank Mario D'Antuono and Hamid Ghorbani for contributions.

    o Reverted to previous default choice of estimator in pair correlation.
    
    o Changed rule for converting bandwidths in pair correlation.

    o Improved handling of boundary pixels in density(), relrisk(), Smooth()
    
    o Improvements to rose diagrams.

    o Fiksel's bandwidth rule.

    o Faster calculation of Ripley's isotropic edge correction.

    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o bw.fiksel
    Fiksel's (1988) rule for smoothing bandwidth for
    estimating the pair correlation function.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o pair correlation functions
    (pcf.ppp, pcfinhom, pcfcross, pcfdot, pcfmulti,
    pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom)
    The default value of 'divisor' has been changed to "r"
    (reverting to the behaviour in spatstat.explore 3.7-0 and earlier)
    until some technical problems are resolved.

    o pair correlation functions
    (pcf.ppp, pcfinhom, pcfcross, pcfdot, pcfmulti,
    pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom)
    The rule for converting bandwidth 'bw' from the distance scale to the
    area scale (when divisor="a") has changed.

    o pcfinhom
    Argument 'adjust' has been renamed 'adjust.bw' to avoid confusion.
    However 'adjust' is still accepted.

    o density.ppp, density.psp, relrisk.ppp, Smooth.ppp
    These methods now accept the argument 'rule.pix' passed to 'owin2mask'.
    This makes it possible to ensure that boundary pixels which partially
    intersect the window are included in the resulting pixel image,
    by setting op="cover".

    o rose.default, rose.histogram, rose.density, rose.fv, circdensity
    Rose diagrams can now be computed and plotted for data
    expressed in any units with any period (such as hours in a 24-hour day).
    More options for argument 'unit'.
    New argument 'fullcircle'.

    o rose.default, rose.histogram
    Polygons are now filled, by default, in light grey.
    New formal argument 'col' specifies the fill colour(s).

    o rose.default, rose.histogram, rose.density, rose.fv
    New argument 'do.ticks' controls whether tick marks are drawn.

    o rose.default, rose.histogram, rose.density, rose.fv
    Concentric rings are now drawn inside the circle, for scale.
    New argument 'do.rings'.

    o rose.default, rose.histogram, rose.density, rose.fv
    The return value now has attribute "R" giving the
    radius of the outer circle of the diagram, and attribute "rings"
    giving the radii of the concentric scale rings.

    o rose.fv
    Now plots multiple curves, if there are multiple columns of values.
    New argument 'fmla' controls which columns of values are plotted.

    o rose.fv
    Now handles envelopes (objects of class 'envelope') as well.

    o rose.default, rose.histogram, rose.density, rose.fv
    New argument 'root' specifies whether to apply a square root transformation.

    o Summary functions
    Calculation of Ripley's isotropic edge correction has been accelerated,
    and responds more quickly to user interrupts.

    o edge.Ripley
    New optional argument 'bdistX'. 

    o edge.Ripley
    Responds more quickly to user interrupts
    (STOP command, Ctrl-C signal).
    
BUG FIXES

    o pcfdot, pcfcross, pcfdot.inhom, pcfcross.inhom
    Envelopes for these functions were sometimes incorrect in the sense that
    the summary functions were not all calculated with the same settings.
    [Spotted by Hamid Ghorbani.]
    Affected spatstat.explore 3.8-0 only.
    Fixed.

    o plot.fv
    Occasionally gave a strange warning about 'distmap' methods.
    Fixed.
    
    o rose.default, rose.histogram
    Crashed if argument 'labels' was given.
    [Spotted by Mario D'Antuono.]
    Fixed.

    o rose.default, rose.histogram
    Geometry of plot was sometimes incorrect when clockwise=FALSE.
    [Spotted by Mario D'Antuono.]
    Fixed.

    o rose.default, rose.histogram
    Ignored arguments 'freq' and 'probability'.
    Fixed.
    
    o rose.default, rose.histogram, rose.density, rose.fv
    Argument 'do.plot=FALSE' was partially ignored (i.e. a graphics device
    was opened and some graphical commands were issued).
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.8-0

OVERVIEW

    o We thank Andrew Bevan, Meri Bilan, Tilman Davies,
    Andrea Gilardi and Martin Hazelton for contributions.
    
    o Important changes to default settings for pair correlation functions.

    o More flexible interpretation of arguments 'lambda = <ppm>" 
    in inhomogeneous summary statistics

    o New options for multitype pair correlation functions.

    o More options for 'simulate' argument in 'envelope' methods.

    o Specify the 'theoretical' value of the summary function in 'envelope'

    o Extended capability of 'envelope.pp3' 

    o Method of T.F. Cox for identifying dense and sparse regions of points.

    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o coxmap
    Given a point pattern, divide the spatial region into
    areas where the pattern is dense, sparse or neither,
    using the method of T.F. Cox (1979).

SIGNIFICANT USER-VISIBLE CHANGES

    o pcf.ppp, pcfinhom
    The default value of 'divisor' has changed to "a",
    so that the new area-based estimator is the default.

    o pcf.ppp, pcfinhom
    The default value of 'zerocor' is now 'JonesFoster' for small patterns
    and 'convolution' for larger patterns.

    o pcf.ppp, pcfinhom
    New argument 'nsmall' determines the threshold for large patterns.

    o pcfinhom
    Default value of 'normpower' has changed to 2.

    o pcfcross, pcfdot, pcfmulti
    The default estimation method has changed. The new default is
    based on squared distances (divisor="a").

    o pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom
    The default estimation method has changed. The new default is
    based on squared distances (divisor="a").

    o pcfmulti, pcfmulti.inhom
    New arguments h, bw.args, adjust, zerocor, nsmall, gref, tau, close.
    
    o pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom, 
    Interpretation of arguments 'lambdaI', 'lambdaJ', 'lambdaX', 'lambdadot'
    has changed when they are fitted point process models. If the model is
    a multitype point process then it is assumed to be a model for the 
    entire point pattern X, while if the model is an unmarked point process
    then it is assumed to be a model for the relevant subset of the data.

    o Kcross.inhom, Kdot.inhom, Kmulti.inhom
    Interpretation of arguments 'lambdaI', 'lambdaJ', 'lambdaX', 'lambdadot'
    has changed when they are fitted point process models. If the model is
    a multitype point process then it is assumed to be a model for the 
    entire point pattern X, while if the model is an unmarked point process
    then it is assumed to be a model for the relevant subset of the data.

    o pcfcross, pcfdot
    Shortened list of formal arguments (other arguments pass to 'pcfmulti')
    
    o pcfcross.inhom, pcfdot.inhom
    Shortened list of formal arguments 
    (other arguments are passed to 'pcfmulti.inhom')
    
    o density.ppp
    Argument 'weights' can be logical valued.

    o intensity.ppp
    Argument 'weights' can be logical valued.

    o markcorr, markcrosscorr
    Argument 'weights' can be logical valued.

    o relrisk.ppp
    Argument 'weights' can be logical valued.

    o envelope.ppp
    Argument 'simulate' can be a point process model of class
    'ppm', 'kppm', 'dppm', 'slrm', 'clusterprocess' or 'detpointprocfamily'.

    o envelope.pp3
    Marked point patterns are now accepted.

    o envelope.pp3
    New arguments 'fix.n' and 'fix.marks' determine whether the 
    simulated patterns have a fixed or random number of points.

    o envelope.ppp, envelope.pp3
    New argument 'theoryfun' can be used to provide the theoretical value
    of the summary function.

    o hopskel, hopskel.test
    Accelerated.

BUG FIXES

    o quadrat.test
    Crashed when argument 'lambda' was an image or function on a linear network.
    [Spotted by Andrea Gilardi.]
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.7-0

OVERVIEW

    o Important changes to mark correlation function.

    o Summary functions have argument 'rmax'.
    
    o Minor internal improvements.

SIGNIFICANT USER-VISIBLE CHANGES

    o markcorr
    The interpretation of the argument 'weights' has changed.

    o markcorr
    New argument 'fadjust' (equivalent to the old 'weights').

    o markcrosscorr
    New argument 'weights'.

    o plot.fasp
    Now returns a list containing the results of plot.fv for each panel.

    o summary functions
    The following functions have a new formal argument 'rmax':
    Fest, Finhom, FmultiInhom,
    Gcross, Gdot, Gest, Ginhom, Gmulti, GmultiInhom,
    Jest, Jcross, Jdot, Jinhom, Jmulti,
    Kcross, Kdot, Kinhom, Kmulti,
    Kcross.inhom, Kdot.inhom, Kmulti.inhom, Kmark, Ksector,
    markconnect, markcorr, markcorrint, markcrosscorr, markequal, markvario,
    pcf.ppp, pcfcross, pcfdot, pcfmulti,
    pcfinhom, pcfcross.inhom, pcfdot.inhom, pcfmulti.inhom.

BUG FIXES

    o plot.fv
    Crashed sometimes if the formula involved the name of
    an object that was not a column of x.
    Fixed.
    
        CHANGES IN spatstat.explore VERSION 3.6-0

OVERVIEW

    o We thank Lucia Cobo Sanchez and Tilman Davies for contributions.

    o Nearest neighbour counting functions.

    o Tolerance contours for relative risk.

    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o markequal
    Mark equality function e(r) for multitype point patterns.
    
    o nnequal, nncount
    Summary functions for multitype point patterns
    based on the types of nearest neighbours.

    o tolcon
    Tolerance contours for spatial relative risk.

SIGNIFICANT USER-VISIBLE CHANGES

    o markcorr, markconnect, markvario, Emark, Vmark
    The result now has an attribute 'smooth.args'
    containing the smoothing parameters used.

BUG FIXES

   o Kmark
   Calculation was incorrect for multitype patterns (categorical marks).
   Fixed.

   o as.data.frame.fv
   Some attributes of x were incorrectly retained.
   Fixed.
   
        CHANGES IN spatstat.explore VERSION 3.5-3

OVERVIEW

    o Summary functions handle NA objects.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o Summary functions 
    (Kest, Kest.fft, Kcross, Kdot, Kmulti, Kscaled,
    Kinhom, Kcross.inhom, Kdot.inhom, Kmulti.inhom,
    Lest, Lcross, Ldot, Linhom, Lscaled, Lcross.inhom, Ldot.inhom,
    pcf, pcfcross, pcfdot, pcfmulti, pcfinhom, pcfcross.inhom, pcfdot.inhom,
    Fest, Gest, Gcross, Gdot, Gmulti, Jest, Jcross, Jdot, Jmulti, Iest,
    Finhom, Ginhom, Jinhom, markcorr, markvario, markconnect, Emark, Vmark)
    If X is a missing point pattern, a missing object of class 'fv' is returned.

   o Local summary functions
    (localL, localK, localLcross, localKcross, localLdot, localKdot
    localLcross.inhom, localKcross.inhom, localLdot.inhom, localKdot.inhom)
    If X is a missing point pattern, a missing 'data.frame' is returned.

   o allstats, alltypes
   If the first argument is a missing point pattern,
   a missing object of class 'fasp' is returned.

   o Kmeasure
   If X is a missing point pattern, a missing pixel image is returned.
   
        CHANGES IN spatstat.explore VERSION 3.5-2

OVERVIEW

    o Internal fixes.
    

        CHANGES IN spatstat.explore VERSION 3.5-1

OVERVIEW

    o Tweak documents to satisfy CRAN.
    

        CHANGES IN spatstat.explore VERSION 3.5-0

OVERVIEW

    o We thank Jakob Jentschke and Suman Rakshit for contributions.
    
    o Extension of ROC curves.

    o Shrinkage estimate in Smooth.ppp.
    
    o Youden index.

    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o roc.rhohat, roc.cdftest, roc.bermantest
    Calculate ROC from other kinds of data.
    
    o roc.im
    Calculate ROC from a pixel image such as an estimate of intensity.
    
    o youden
    Youden statistic for ROC curves.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o cov.im, cor.im
    Default changed to 'use="complete.obs"'.
    
    o roc.ppp
    New argument 'baseline' allows calculation of ROC relative to a baseline.

    o roc.ppp
    New argument 'weights' for numerical weights on the data points.

    o roc.ppp
    New argument 'observations' specifies whether to use the exact point
    coordinates or pixel presence-absence indicators.

    o roc.ppp
    New argument 'method' determines the estimation method.
    New options include a kernel smoothing estimate and a monotone estimate.

    o roc.ppp
    New arguments 'CI', 'alpha' for calculating confidence intervals.

    o roc.ppp
    New argument 'subset' specifies a sub-region of the spatial domain
    in which the ROC should be calculated.

    o Smooth.ppp
    Shrinkage estimate implemented.
    New arguments 'shrink' and 'shrinktype'.

    o Smooth.ppp
    Slight change to algorithm for handling very small bandwidths.

    o SpatialQuantile.ppp, SpatialMedian.ppp
    Slight change to algorithm for handling very small bandwidths.

        CHANGES IN spatstat.explore VERSION 3.4-3

OVERVIEW

    o Shrinkage estimator of relative risk.

    o Normalised relative risk.

    o Extensions to cross-validated bandwidth selection for smoothing.

    o Bug fixes.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o relrisk.ppp
    New argument 'shrink' supports Bithell's shrinkage estimator.

    o relrisk.ppp
    New argument 'normalise' controls whether the estimate will be
    normalised so that constant risk corresponds to the value 1.

    o bw.smoothppp
    New arguments 'train' and 'test' for cross-validation.

BUG FIXES

    o Smooth.ppp
    The estimate of standard error could sometimes take the value NaN.
    Fixed.

    o Smooth.ppp
    Terminated in some cases with error message "oo not found".
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.4-2

OVERVIEW

    o Minor fix.


        CHANGES IN spatstat.explore VERSION 3.4-1

OVERVIEW

    o Minor change to documentation to satisfy CRAN package checker.

        CHANGES IN spatstat.explore VERSION 3.4-0

OVERVIEW

    o We thank Ya-Mei Chang, Tilman Davies, Martin Hazelton
    and Tingting Zhan for contributions.
    
    o New estimator of pair correlation function.

    o New methods for bandwidth selection for pair correlation estimation.

    o Helper functions for measuring estimator performance.

NEW FUNCTIONS

    o bw.bdh
    Adjust bandwidth of kernel estimate of pair correlation function,
    to account for inhomogeneity.

    o bw.pcfinhom
    Cross-validation rule for selecting bandwidth of kernel estimate
    of (inhomogeneous) pair correlation function.

    o ptwise.envelope, bias.envelope, RMSE.envelope
    Calculate pointwise statistics of the simulated function values
    in an envelope object.
    
    o ISE.envelope, ISB.envelope, IV.envelope
    Integrated squared error, integrated squared bias, integrated variance
    of the simulated function values in an envelope object.
    
    o MISE.envelope
    Mean integrated squared error of the simulated function values
    in an envelope object.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o pcf.ppp
    New option: divisor="a" calculates a new estimator of the pcf
    with improved performance.
    
    o pcfinhom
    New option: divisor="a" calculates a new estimator of the inhomogeneous pcf
    with improved performance.

    o bw.stoyan
    New argument 'extrapolate' supports a modification of Stoyan's rule.
    
    o plot.fv
    New argument 'do.plot'.

        CHANGES IN spatstat.explore VERSION 3.3-4

OVERVIEW

    o Minor improvements.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o reload.or.compute
    New argument 'exclude' specifies which objects should not be saved.

        CHANGES IN spatstat.explore VERSION 3.3-3

OVERVIEW

    o relative risk estimation using diffusion.

    o smoothing using diffusion.

    o Tweaks to bandwidth selection.

NEW FUNCTIONS

    o relriskHeat, relriskHeat.ppp
    Relative risk estimation using diffusion.

    o blurHeat, blurHeat.im
    Image smoothing using diffusion.

    o SmoothHeat, SmoothHeat.ppp
    Smoothing numerical values observed at points, using diffusion.

    o bw.relriskHeatppp
    Bandwidth selection for relriskHeat.ppp

SIGNIFICANT USER-VISIBLE CHANGES

    o bw.ppl
    Argument 'shortcut' now defaults to TRUE.

        CHANGES IN spatstat.explore VERSION 3.3-2

OVERVIEW

    o Tweaks to documentation.

    o Internal repairs.

    o Internal changes to satisfy package checker.

        CHANGES IN spatstat.explore VERSION 3.3-1

OVERVIEW

    o Internal changes to satisfy package checker.
    
    
        CHANGES IN spatstat.explore VERSION 3.3-0

OVERVIEW

    o 'spatstat.explore' now depends on package 'spatstat.univar'.

    o Some functions have been moved to 'spatstat.univar'.
    
    o Minor improvements.

PACKAGE DEPENDENCE

    o spatstat.explore now depends on the new package 'spatstat.univar'

    o Some functions have been moved
    from 'spatstat.explore' to 'spatstat.univar'.

SIGNIFICANT USER-VISIBLE CHANGES

    o cbind.fv, bind.fv
    Additional arguments may be functions in the R language.

DELETED FUNCTIONS

    o bw.abram
    The generic 'bw.abram' has been moved
    to the new package 'spatstat.univar'.
    
    o CDF, CDF.density
    The generic 'CDF' and method 'CDF.density' have been moved
    to the new package 'spatstat.univar'.

    o densityAdaptiveKernel
    The generic 'densityAdaptiveKernel' has been moved
    to the new package 'spatstat.univar'.
    
    o dkernel, pkernel, qkernel, rkernel
    These functions have been moved to the new package 'spatstat.univar'.

    o kernel.factor, kernel.moment, kernel.squint
    These functions have been moved to the new package 'spatstat.univar'.

    o kaplan.meier, reduced.sample, km.rs
    These functions have been moved to the new package 'spatstat.univar'.

    o quantile.density
    This method has been moved to the new package 'spatstat.univar'.

    o stieltjes
    This function has been moved to the new package 'spatstat.univar'.

        CHANGES IN spatstat.explore VERSION 3.2-7

OVERVIEW

    o Bug fixes.

    o Internal improvements.

BUG FIXES

    o SpatialMedian.ppp, SpatialQuantile.ppp
    Argument `sigma' was ignored in some calculations.
    Fixed.


        CHANGES IN spatstat.explore VERSION 3.2-6

OVERVIEW

    o We thank Mohomed Abraj, Marcelino de la Cruz and Stephanie Hogg
      for contributions.
    
    o Spatially weighted median and quantile of mark values.
    
    o Adaptive estimation of intensity for split point patterns.

    o Anisotropic bandwidth selection

    o Boyce index.
    
    o Internal improvements.
    
    o Bug fixes.

NEW FUNCTIONS

    o SpatialMedian.ppp, SpatialQuantile.ppp
    Spatially weighted median and quantile of mark values of a point pattern.

    o boyce
    Boyce index and continuous Boyce index.
    
    o densityAdaptiveKernel.splitppp
    A method for 'densityAdaptiveKernel' for split point patterns.

SIGNIFICANT USER-VISIBLE CHANGES

    o bw.ppl
    New argument `varcov1' for anisotropic bandwidth selection.

    o bw.smoothppp
    New argument `varcov1' for anisotropic bandwidth selection.

BUG FIXES

    o studpermu.test
    The code required each group to consist of at least 3 point patterns,
    rather than 2 point patterns (as stated in the documentation).
    Fixed.

    o Jest
    Ignored pixel resolution argument 'eps'.
    Fixed.

    o scanLRTS
    Pixel resolution arguments 'dimyx', 'eps', 'xy' were not correctly handled.
    Fixed.
    
        CHANGES IN spatstat.explore VERSION 3.2-5

OVERVIEW

    o Minor corrections in documentation.

        CHANGES IN spatstat.explore VERSION 3.2-4

OVERVIEW

    o Integration of functions.

    o Changed defaults for Clark-Evans Test.

    o spatstat.explore no longer suggests package 'maptools'.
    
    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o integral.fv
    Compute the integral of a function.

SIGNIFICANT USER-VISIBLE CHANGES

    o density.ppp
    New argument 'sameas'.

    o clarkevans.test
    The asymptotic test is now available for any choice of edge correction.

    o clarkevans.test
    New argument 'method' determines whether to use the asymptotic test
    or Monte Carlo test. The default has changed to method='asymptotic'.

    o clarkevans.test
    Default edge correction has changed, to avoid bias.

BUG FIXES

    o kernel.squint
    The return value was incorrect if the argument 'bw' was given.
    Fixed.
    
    o pcf
    The variance approximation was calculated incorrectly
    (due to the bug in kernel.squint).
    Fixed.
    
    o quantile.density
    Crashed if `probs` contained NA values and `names=FALSE`.
    Fixed.

    o bw.smoothppp
    Crashed if every point in 'X' was duplicated.
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.2-3

OVERVIEW

    o Improvements to envelope methods.
    
    o Suppress warning messages from density.default.
    
    o Minor improvements and bug fixes.

NEW FUNCTIONS

    o compileCDF
    Low level utility for calculating cumulative distribution function
    of distance variable. 

SIGNIFICANT USER-VISIBLE CHANGES

    o circdensity
    Improved output of 'print' method

    o envelope
    All methods for `envelope' now accept a summary function 
    in which the function argument is not named 'r'.
    This includes functions such as `transect.im' and `roc'.
    
    o plot.bermantest
    Improved layout for plots of Berman's Z2 test.

    o plot.fv
    New argument 'clip.xlim'.

    o circdensity
    Suppress annoying warning messages from density.default.
    
    o compileK, compilepcf
    Suppress annoying warning messages from density.default.
    
    o rhohat
    Suppress annoying warning messages from density.default.
    
BUG FIXES

    o envelope methods
    Results were malformed if the name of the function argument was not "r". 
    Fixed.
    
        CHANGES IN spatstat.explore VERSION 3.2-1

OVERVIEW

    o Internal bug fixes.


        CHANGES IN spatstat.explore VERSION 3.2-0

OVERVIEW

    o We thank Jonatan Gonzalez for contributions.
    
    o Changed the calculation of standard errors in density.ppp and relrisk.ppp.

    o Inline arithmetic for function tables ('fv') and arrays ('fasp')

    o Standard error calculation for Smooth.ppp (experimental)
    
    o multitype pair correlation functions can save numerator and denominator.

    o multitype inhomogeneous J functions.

    o More support for automatic bandwidth selection.
    
    o Bug fixes in calculation of standard errors.

NEW FUNCTIONS

    o Math.fv, Complex.fv, Summary.fv, Ops.fv
    Methods for arithmetic operations for function tables (class 'fv')
    
    o Math.fasp, Complex.fasp, Summary.fasp, Ops.fasp
    Methods for arithmetic operations for function arrays (class 'fasp')

    o Gcross.inhom, Gdot.inhom
    Multitype G functions for inhomogeneous point processes.
    
    o Jcross.inhom, Jdot.inhom, Jmulti.inhom
    Multitype J functions for inhomogeneous point processes.

    o summary.bw.optim, print.summary.bw.optim
    Method for 'summary' of optimised bandwidth objects (class 'bw.optim').
    These are the objects produced by the bandwidth selection functions
    such as bw.diggle, bw.scott, bw.pcf
    
SIGNIFICANT USER-VISIBLE CHANGES

    o density.ppp
    Standard error calculation is now available with any smoothing kernel.

    o density.ppp
    The interpretation of 'weights' in the calculation of standard error
    has changed. New argument 'wtype' controls this interpretation.
    
    o relrisk.ppp
    The interpretation of 'weights' in the calculation of standard error
    has changed. New argument 'wtype' controls this interpretation.

    o relrisk.ppp
    New argument 'fudge' specifies a constant numeric value that will be
    added to each estimate of point process intensity before calculation of
    relative risk.
    
    o Smooth.ppp
    Standard error calculation is now supported (Experimental).

    o pcfcross, pcfdot, pcfmulti
    New argument 'ratio' makes it possible to save the numerator and
    denominator of the function estimates, so that estimates can be pooled.
    
    o bw.relrisk.ppp
    Additional arguments '...' are now passed to 'density.ppp'.

    o eval.fasp
    Automatically-generated labels have been improved.

    o relrisk.ppp
    Issues a warning if numerical underflow is detected.

    o rhohat.ppp, rhohat.quad
    New argument 'rule.eps' passed to 'as.mask'.
    
BUG FIXES

    o density.ppp
    Calculation of standard error was slightly incorrect if edge=TRUE.
    Fixed.
    
    o relrisk.ppp
    Calculation of standard error was incorrect for non-Gaussian kernels.
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.1-0

OVERVIEW

    o Pair correlation functions allow more control over smoothing parameters.
    
    o Improved support for one-dimensional smoothing kernels.

    o Bug fixes in plot.fv.

    o Internal improvements and bug fixes.

SIGNIFICANT USER-VISIBLE CHANGES

    o kernel.moment
    New arguments 'mean' and 'sd'.
    Computation accelerated for kernel='cosine' or 'optcosine'.
    All cases are now computed using analytic expressions, for m <= 2.

    o bw.abram
    This function is now generic, with a method for class 'ppp'.

    o pcfinhom, pcfdot.inhom, pcfcross.inhom
    New arguments 'adjust.sigma' and 'adjust.bw' allow
    separate adjustment of the one-dimensional smoothing bandwidth 'bw'
    and the spatial smoothing bandwidth 'sigma'.
    
BUG FIXES

    o plot.fv
    When the argument 'log' was given, the plotted curves were
    incorrectly clipped, or were missing altogether.
    Fixed.
    
    o plot.fv
    If 'add=TRUE', and if the existing plot was created using logarithmic axes,
    the logarithmic scale was ignored.
    Fixed.
    
    o plot.fv
    Sometimes gave an obscure warning about 'rebound.owin',
    when 'xlim' or 'ylim' was given.
    Fixed.

        CHANGES IN spatstat.explore VERSION 3.0-6

OVERVIEW

    o Internal improvements and bug fixes.

        CHANGES IN spatstat.explore VERSION 3.0-5

OVERVIEW

    o Bug fix in pcf.

    o We thank Maximilian Hesselbarth for contributions.
    
BUG FIXES

    o pcf.ppp
    Estimates were incorrectly scaled (they were incorrectly multiplied
    by the area of the window.) Spotted by Maximilian Hesselbarth.
    Bug introduced in spatstat.explore 3.0-0.
    Fixed.
    

        CHANGES IN spatstat.explore VERSION 3.0-4

OVERVIEW

    o Bug fix in Kest in a very special case.

    o We thank 'Marjolein9' for contributions.
    
BUG FIXES

    o Kest
    Isotropic edge correction weight was computed incorrectly
    for a data point lying exactly on a corner of a rectangular window.
    Spotted by GitHub contributor 'Marjolein9'.
    Fixed.
    
        CHANGES IN spatstat.explore VERSION 3.0-3

OVERVIEW

    o Tweaks to placate package checker.


        CHANGES IN spatstat.explore VERSION 3.0-2

OVERVIEW

    o Tweaks to placate package checker.


        CHANGES IN spatstat.explore VERSION 3.0-1

OVERVIEW

    o Tweaks to placate package checker.


        CHANGES IN spatstat.explore VERSION 3.0-0

OVERVIEW

    o New package

    o We thank Marie-Colette van Lieshout and Daniel Manrique-Castano
    for contributions.
    
    o Periodic edge correction for K function.

    o Changed denominator in K function and pair correlation function.
    
    o Bandwidth selection for adaptive kernel estimation of intensity.

    o U-shaped curves in 'rhohat'.

    o Radial cumulative integral of an image.
    
    o Minor improvements.

NEW FUNCTIONS

    o bw.CvL.adaptive
    Bandwidth selection for adaptive kernel estimation of intensity.

    o radcumint
    Radial cumulative integral of an image.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o Package structure
    The package 'spatstat.core' has been split into two packages called
    'spatstat.explore' (for exploratory data analysis)
    and 'spatstat.model' (for modelling and formal inference).

    o spatstat.explore
    The new package 'spatstat.explore' contains the code for
    exploratory data analysis and nonparametric analysis
    of spatial data. Examples include 'density.ppp', 'Kest',
    'envelope', 'rhohat', 'clarkevans.test'.

    o NEWS
    The NEWS file for the new package 'spatstat.explore'
    contains older news items from the defunct package 'spatstat.core'
    (for functions which are now in 'spatstat.explore').

    o Kest, Kdot, Kcross, Ldot, Lcross, Kmulti
    These functions now accept the option 'correction="periodic"'
    to compute the periodic (toroidal) edge correction estimate.

    o Kest, pcf, Ksector, Kdot, Kcross, Kmulti
    When ratio=TRUE, the denominator is now equal to the number of pairs of
    points considered. This does not affect the estimate of the summary
    function, but it changes the calculation of pooled estimates
    when the estimates were obtained from different sized windows.
    
    o markcorr, markcrosscorr
    These functions now allow negative mark values when normalise=FALSE.
    
    o marktable
    This function now works for point patterns in three dimensions (class 'pp3')
    and point patterns on a network (class 'lpp').
    
    o bw.relrisk
    This function is now generic, with a method for class 'ppp'

    o compileK, compilepcf
    These functions have a new argument 'samplesize'.
    If 'ratio=TRUE' the numerator and denominator will be rescaled
    by a common factor so that the denominator is equal to 'samplesize'.

    o adaptive.density
    Now accepts 'method="nearest"' and passes the data to 'nndensity'.

    o rhohat.ppp
    New options 'smoother="mountain"' and 'smoother="valley"'
    for estimating a unimodal function (U-shaped curve).

    o rhohat.ppp
    If the covariate is a 'distfun', the name of the unit of length is saved
    and displayed on the plot.

    o rhohat.ppp
    New arguments 'jitter', 'jitterfactor', 'interpolate' allow greater
    control over the calculation.

    o rhohat.ppp
    New argument 'do.CI' specifies whether to calculate confidence bands.
    
        CHANGES IN spatstat.core VERSION 2.4-4.010

OVERVIEW

    o Internal improvements.


        CHANGES IN spatstat.core VERSION 2.4-4

OVERVIEW

    o Bug fixes and minor improvements.

BUG FIXES

    o rhohat.ppp
    The argument 'subset' was not handled correctly in the internal data.
    The estimated function 'rho' was correct, but if 'predict.rhohat' was applied,
    predictions were computed only in the 'subset', and were possibly incorrect values.
    Fixed.

    o Gfox, Jfox
    Warnings were issued about text formatting errors (mentioning 'sprintf' or 'fmt').
    Fixed.
    
        CHANGES IN spatstat.core VERSION 2.4-3

OVERVIEW

    o We thank Art Stock for contributions.
    
    o Bug fixes and minor improvements.

BUG FIXES

    o Smooth.ppp
    Crashed when 'kernel' was a function, 'at="points"' and 'scalekernel=FALSE'.
    Fixed.

    o Finhom, Ginhom, Jinhom
    Crashed when ratio=TRUE.
    [Spotted by Art Stock.]
    Fixed.
    
    o envelope
    Crashed for some of the summary functions when ratio=TRUE.
    [Spotted by Art Stock.]
    Fixed.

    o "[.rat"
    Crashed in some cases.
    Fixed.

    o Kcross
    The result of Kcross() was 'invisible',
    i.e. it was not automatically printed.
    Fixed.
    
        CHANGES IN spatstat.core VERSION 2.4-2

OVERVIEW

    o Internal bug fixes.


        CHANGES IN spatstat.core VERSION 2.4-1

OVERVIEW

    o We thank Frederic Lavancier, Sebastian Meyer, Suman Rakshit and Sven Wagner
    for contributions.
    
    o Improved approximation of intensity of Gibbs models.
    
    o Experimental code to represent (theoretical) point process models
    
    o Extract more information about a point process model.

    o Internal improvements and bug fixes.

SIGNIFICANT USER-VISIBLE CHANGES

    o relrisk.ppp
    Ratios which are close to 0/0 are handled more effectively,
    reducing the likelihood of strange-looking plots when 'sigma' is very small.

BUG FIXES

    o density.ppp
    Crashed if the observation window had zero area.
    Fixed.

    o dirichletVoronoi.ppp
    Crashed randomly, with obscure error messages from 'im' or 'eval.im',
    when argument 'f' had a small value.
    [Spotted by Suman Rakshit.]
    Fixed.

    o dirichletVoronoi.ppp
    Rarely, produced an image containing NA values.
    [Spotted by Suman Rakshit.]
    Fixed.

    o vcov.ppm
    Crashed in some cases, with message 'object lamdel not found'.
    [Spotted by Sven Wagner.]
    Fixed.
    
        CHANGES IN spatstat.core VERSION 2.4-0

OVERVIEW

    o We thank Sriram Ramamurthy for contributions.

    o spatstat.core now depends on the new package 'spatstat.random'.

    o Functions for generating random patterns have been removed.
    
    o Minor improvements and bug fixes

SIGNIFICANT USER-VISIBLE CHANGES

    o package structure
    The code for generating random spatial patterns (including 'rpoispp',
    'rMatClust', 'rThomas', 'rNeymanScott', 'rStrauss', 'rmh')
    has been removed from 'spatstat.core' and placed in a new package
    'spatstat.random'. This new package is required by 'spatstat.core'.

    o reload.or.compute
    New argument 'context' 

BUG FIXES

    o reload.or.compute
    Scoping error (crashed sometimes if called from a non-global environment).
    Fixed.
    
        CHANGES IN spatstat.core VERSION 2.3-2

OVERVIEW

    o Minor improvements and bug fixes.

    o We thank Jonas Brehmer for contributions.

SIGNIFICANT USER-VISIBLE CHANGES

    o pcf
    Improved error message
    
BUG FIXES

    o edge.Ripley
    Results were incorrect for data points lying exactly at the corners
    of a rectangle.
    Fixed.

        CHANGES IN spatstat.core VERSION 2.3-1

OVERVIEW

    o Covariates in ppm and mppm may be functions that depend on the marks
    as well as the spatial coordinates.

    o Automatic selection of threshold for defining a binary predictor.
    
    o Random perturbation of line segments.
    
    o Minor extensions, performance improvements, and bug fixes.

NEW FUNCTIONS

    o thresholdSelect, thresholdCI
    Select the optimal threshold for converting a numerical predictor
    to a binary predictor.
    
    o coef<-.fii
    Changes the coefficients of a fitted interaction object
    (a method for the generic "coef<-")

SIGNIFICANT USER-VISIBLE CHANGES

    o distcdf
    Improved regularisation algorithm.
    Argument 'nr=NULL' is now accepted.
    New argument 'delta' allows the result to be interpolated
    onto a finer grid.

    o collapse.fv
    Columns identified by the arguments 'same' and 'different'
    may now be absent from some of the 'fv' objects that will be collapsed.

    o Kest
    When the argument 'domain' is given, the calculation of estimates of K(r)
    has changed slightly, to adhere more closely to the description in
    the help file.
    
    o reload.or.compute
    Now prints a message indicating whether the data were recomputed
    or reloaded from file.
    New argument 'verbose'.

    o pool.envelope
    Now uses the value of 'nrank' which was used in the original envelopes.
    
    o Kmulti
    New argument 'rmax'.

    o Kinhom
    No longer issues a warning about changed behaviour in the case where
    'lambda' is a fitted model.
    
    o pcfinhom
    No longer issues a warning about changed behaviour in the case where
    'lambda' is a fitted model.
    
BUG FIXES

    o segregation.test
    The test statistic was calculated as the mean, rather than the sum,
    of discrepancies between probabilities. (The p-value was not affected.)
    Fixed.

    o Kest
    If 'domain' was specified, 'rmax' was ignored.
    Fixed.

    o edge.Ripley
    Value was incorrect for a point lying exactly on a corner.
    Fixed.

    o edge.Ripley
    Crashed when method="interpreted", if a point lay exactly on a corner.
    Fixed.

    o plot.fv, plot.envelope
    Crashed when trying to display a significance band of width zero
    around a constant function.
    Fixed.
    
    o collapse.fv
    Crashed if 'length(same) > 1'.
    Fixed.

        CHANGES IN spatstat.core VERSION 2.3-0

OVERVIEW

    o Transect of an image along a curve.

    o Image cross-correlation and cross-covariance.
    
    o Minor bug fixes.

NEW FUNCTIONS

    o cov.im, cor.im
    Correlation or covariance between several pixel images.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o transect.im
    New argument 'curve' allows the user to specify a curved transect.

BUG FIXES

    o rhohat
    The rug plot (produced by plot.rhohat) was incorrect
    when rhohat was called with method="piecewise".
    Fixed.

    o markcrosscorr
    Did not recognise the option 'correction="none"'.
    Fixed.

   o roc.ppp
   The default plot of the result of roc.ppp
   did not include the diagonal line 'y=x'.
   Fixed.
   
        CHANGES IN spatstat.core VERSION 2.2-0

OVERVIEW

    o We thank Abdollah Jalilian, Yongtao Guan and Rasmus Waagepetersen
    for contributions.
    
    o estimation of the spatial covariance function of a pixel image

    o simulation of the product shot noise Cox process.

    o extensions to rhohat
    
NEW FUNCTIONS

    o rPSNCP
    Generate simulated realisations of the product shot noise Cox process.
    Contributed by Abdollah Jalilian, Yongtao Guan and Rasmus Waagepetersen.
    
    o spatcov
    Estimate the spatial covariance function of a pixel image.

    o pairMean
    Compute the mean of a specified function of interpoint distance
    between random points in a window.

SIGNIFICANT USER-VISIBLE CHANGES

    o rhohat
    New option (smoother='piecewise') computes a piecewise-constant
    estimate of rho(z).
    
    o rhohat
    The result now includes the 'average' intensity rho.

    o distcdf
    Arguments which are NULL will be treated as missing.

    o distcdf
    New argument 'savedenom'.
    

        CHANGES IN spatstat.core VERSION 2.1-2

OVERVIEW

    o Reduced CRAN check time.

        CHANGES IN spatstat.core VERSION 2.1-1

OVERVIEW

    o Minor bug fix

        CHANGES IN spatstat.core VERSION 2.1-0

OVERVIEW

    o densityfun.ppp handles query points outside original window

    o Minor improvements and bug fixes.

SIGNIFICANT USER-VISIBLE CHANGES

    o densityfun.ppp
    The resulting function can now handle query points which lie
    outside the window of the original data,
    and has argument 'drop=TRUE' which specifies how to handle them.

    o rpoint
    New argument 'forcewin' forces the code to use the window 'win'
    when 'f' is a pixel image.

BUG FIXES

    o cdf.test
    Crashed if the covariate was constant.
    Fixed.

        CHANGES IN spatstat.core VERSION 2.0-0

OVERVIEW

    o We thank Tilman Davies,  Greg McSwiggan and Suman Rakshit
    for contributions.

    o We thank Corey Anderson, Michael Chirico, Andy Craig,
    Marcelino de la Cruz, Tilman Davies, Pavel Fibich,
    Kurt Hornik, Gopalan Nair, Yonatan Rosen and Rasmus Waagepetersen
    for contributions.
    
    o Diffusion kernel smoothing.
    
    o More support for spatial logistic regression models.

    o predict.mppm now works for multitype point process models.

    o Improved handling of 'newdata' in predict.mppm.

    o More support for multi-dimensional patterns.
    
NEW FUNCTIONS

    o densityHeat
    New generic function for diffusion kernel estimation of intensity

    o densityHeat.ppp
    Diffusion kernel estimation of intensity for point pattern in 2 dimensions.
    This is an alternative to density.ppp.

    o intersect.boxx
    Compute intersection of boxes in multi-dimensional space

    o scale.boxx, scale.ppx
    Methods for 'scale' for boxes and patterns in multi-dimensional space

    o shift.boxx, shift.ppx
    Methods for 'shift' for boxes and patterns in multi-dimensional space

    o is.boxx
    Determine whether an object is a multidimensional box

SIGNIFICANT USER-VISIBLE CHANGES

    o rotmean
    The result now has the same 'unitname' as the input object X.
    New argument 'adjust' controls the smoothing bandwidth.
    
    o rlabel
    New argument 'group' specifies that the points are divided into
    several groups, and that relabelling is applied within each group.
    
    o Kcross, Gcross, Jcross
    Function labels (shown on the plot legend) have been
    improved when i = j.

    o anova.mppm
    Issues a warning when applied to random-effects models
    (models fitted using the argument 'random').

BUG FIXES

    o Gest
    If correction="rs" or correction="km", then both the reduced-sample
    (border correction) and Kaplan-Meier corrected estimates were calculated.
    [Spotted by Gopalan Nair.]
    Fixed.

    o simulate.rhohat
    Crashed when applied to rhohat objects computed from data
    on a linear network.
    Fixed.

        CHANGES IN spatstat.core VERSION 1.65-11

OVERVIEW

    o Internal tweaks.
    
        CHANGES IN spatstat.core VERSION 1.65-10

OVERVIEW

    o Minor corrections to documentation.

        CHANGES IN spatstat.core VERSION 1.65-9

OVERVIEW

    o We thank Ian Buller for a suggestion.

    o weights permitted in density calculation for line segments.

SIGNIFICANT USER-VISIBLE CHANGES

    o density.psp
    New argument 'weights'.

        CHANGES IN spatstat.core VERSION 1.65-8

OVERVIEW

    o Minor changes to appease the compiler.

        CHANGES IN spatstat.core VERSION 1.65-7

OVERVIEW

    o We thank Michael Chirico for a contribution.

    o Minor changes to appease the compiler.
    
        CHANGES IN spatstat.core VERSION 1.65-6

OVERVIEW

    o We thank Tilman Davies and Pavel Fibich for contributions.

    o Increased speed for large datasets.

SIGNIFICANT USER-VISIBLE CHANGES

    o rSSI
    Accelerated.
    
    o overall speed
    Changes have been made to the internal code of spatstat 
    which should accelerate computations involving large datasets.

    o localpcf, localpcfinhom
    New argument 'rvalue'.

BUG FIXES

    o rLGCP
    Simulation results for log-Gaussian Cox processes were incorrect
    unless the pixel dimensions and pixel spacings were identical
    on the horizontal and vertical axes. (If pixel dimensions were not
    specified, then the results were incorrect whenever the Frame of the
    simulation window was not a square.) 
    [Spotted by Tilman Davies.]
    Fixed.
    
    o Vmark
    Crashed if normalise=TRUE when there was only one column of marks.
    (Spotted by Pavel Fibich.)
    Fixed.
    
    o nnclean
    Crashed if k >= npoints(X).
    Fixed.

    CHANGES IN spatstat.core VERSION 1.65-5

OVERVIEW

    o Minor changes required by CRAN.
    

        CHANGES IN spatstat.core VERSION 1.65-1

OVERVIEW

    o Added NEWS file.


        CHANGES IN spatstat.core VERSION 1.65-0

OVERVIEW

    o Package initialised at version 1.65-0

SIGNIFICANT USER-VISIBLE CHANGES

    o spatstat.core
    The package 'spatstat.core' has been created from a subset
    of the code in the original 'spatstat' package version 1.65-0.
    It contains the core functionality for statistical analysis of
    spatial data. For an overview, see help("spatstat.core-package")

    o Execution
    The 'spatstat.core' package is slightly faster than the corresponding
    code in the 'spatstat' package, because the procedure for calling
    internal C functions has been streamlined.



